function fInitSCO () {
	if (LMSAPI) {
		//start with SCORM
		fSCORMinitializeSCO ();
		//init if first time (ie. cmi.core.lesson_status == "not attempted")
		rsStatus = fSCORMgetvalue ("cmi.core.lesson_status");
		fSCORMerror ();
		if (rsStatus == "not attempted") {
			fInitSCOUserData ();
		}
		rsSuspendData = fSCORMgetvalue ("cmi.suspend_data")
		fSCORMerror ();
	} else {
		var msCookieInited = fGetCookie ("cookieInited");
		if (msCookieInited != "true") {
			fInitCookie ();
		}
		rsSuspendData = fGetCookie ("suspend_data")
	}
	//this session time
	rdtSCOStartTime = fGetTime ();
}

var rbEndSCO = false
function fEndSCO (tbSaveData, tsData) {
	fDebug("fn fEndSCO: ");
	if (rbEndSCO == false) {
		rbEndSCO = true;
		var msElapsedTime = fGetElapsedTime (rdtSCOStartTime);
		if (tbSaveData != false && rbTrackThisSessionOnly == false) {
			if (LMSAPI) {
				//SCORM exit
//				fSCORMinitializeSCO ();
//				if (!tsData) fSCORMsetvalue ("cmi.suspend_data", rsSuspendData);
//				else fSCORMsetvalue ("cmi.suspend_data", tsData);
				fSCORMsetvalue ("cmi.core.session_time", msElapsedTime, true);
/*				if (rsLearningObjectStatus != "") {
					fSCORMsetvalue ("cmi.core.lesson_status", rsLearningObjectStatus, true)
				}
				if (rsScore != "") fSCORMsetvalue("cmi.core.score.raw", rsScore);*/
				fSCORMfinishSCO ();
			} else {
				if (!tsData) fSetCookie ("suspend_data", rsSuspendData);
				else fSetCookie ("suspend_data", tsData);
			}
		}
		
		if (window.opener != null && window.opener.location.toString ().indexOf ("begin-popup") >-1) {
			//opened with begin-popup
			window.opener.location.href = rsEndPopUpURL;
		} else {
			window.location.href = rsEndPopUpURL;
		}
		window.close();
	}
}

function fResetSCO () {
	fDebug ("fn fResetSCO:")
	if (!LMSAPI) {
		//for cookie tracking only
		fExpireCookie ()
	}
	fEndSCO (false)
}

function fSaveData (tsSuspendData) {
	fDebug ("fSaveData " + tsSuspendData)
	if(rsSuspendData != tsSuspendData && tsSuspendData != "")
		fSCORMsetvalue ("cmi.suspend_data", tsSuspendData);
	rsSuspendData = tsSuspendData;
}

function fSaveScore (tsScore) {
	fDebug ("fSaveScore " + tsScore)
	if(rsScore != tsScore && tsScore != "")
		fSCORMsetvalue("cmi.core.score.raw", tsScore, true);
	rsScore = tsScore;
}

function fSetLearningObjectStatus (tsStatus) {
	
	fDebug ("fSetLearningObjectStatus " + tsStatus)
	if(rsLearningObjectStatus != tsStatus && tsStatus != "")
		fSCORMsetvalue ("cmi.core.lesson_status", tsStatus, true)
		
	rsLearningObjectStatus = tsStatus;
	
	//var msElapsedTime = fGetElapsedTime (rdtSCOStartTime);
//	fSCORMsetvalue ("cmi.core.session_time", msElapsedTime, true);
	
}

function fInitSCOUserData() {
	fDebug ("fn fInitSCOUserData: ");
	rsStatus = "incomplete"
	fSCORMsetvalue ("cmi.core.lesson_status", rsStatus, true);
	fSCORMerror ();
}

function fInitCookie () {
	fDebug ("fn fInitCookie: ");
	fSetCookie ("suspend_data", "");
	fSetCookie ("cookieInited", "true")
}

//returns current time
function fGetTime () {
	var mdtTime = new Date ();
	return mdtTime.getTime ();
}

//returns elsped time in format hh:mm:ss when a start time is passed in
function fGetElapsedTime (tdtStartTime) {
	fDebug ("fn fGetElapsedTime: ");
	var mdtTime = fGetTime ();
	//number of milliseconds
	var miMiliSecs = mdtTime - tdtStartTime;
	//number of seconds
	var miS = miMiliSecs / 1000;
	var miM = miH = 0;
	
	//number of minutes
	miH = parseInt (miS/3600);
	miS = miS - (miH * 3600);
	
	miM = parseInt (miS/60);
	miS = parseInt (miS - (miM * 60));
	
	if (miS < 10) miS = "0" + miS;
	if (miM < 10) miM = "0" + miM;
	if (miH < 10) miH = "0" + miH;

	var msElapsedTime = miH + ":" + miM + ":" + miS;
	return msElapsedTime;
}

var roDebugWindow
function fDebug(tsMessage, tbForce) {
	if (tsMessage != "" && tsMessage != null && (rbDebug || tbForce)) {
		var mbOpen = false
		if (roDebugWindow == null) {
			//no window, so set to open
			mbOpen = true
		} else {
			//window exists
			//alert("--"+roDebugWindow.closed)
			if (roDebugWindow.closed == true) {
				//but closed by the user, so close
				roDebugWindow.close ()
				//then set to open
				mbOpen = true
			}
		}
		if (mbOpen == true) {
			//alert("open debug win");
			roDebugWindow = window.open("debug.htm","moneytraildebug", "height=500,width=400,scrollbars=1,resizable=1,status=no,toolbar=no,menubar=no,location=no,titlebar=no");
		}
		//alert("roDebugWindow:"+roDebugWindow)
		roDebugWindow.focus ()
		var msTimeStamp = fGetTime ()
		var moDebug = roDebugWindow.document.body;
		//alert("mbOpen:"+tsMessage)
		moDebug.innerHTML = "[" + msTimeStamp + "]" + tsMessage + "<br><br>" + moDebug.innerHTML;
	}
}